
/**
  ******************************************************************************
    @file           : main.c
    @brief          : Main program body
  ******************************************************************************
  ** This notice applies to any and all portions of this file
    that are not between comment pairs USER CODE BEGIN and
    USER CODE END. Other portions of this file, whether
    inserted by the user or by software development tools
    are owned by their respective copyright owners.

    COPYRIGHT(c) 2019 STMicroelectronics

    Redistribution and use in source and binary forms, with or without modification,
    are permitted provided that the following conditions are met:
      1. Redistributions of source code must retain the above copyright notice,
         this list of conditions and the following disclaimer.
      2. Redistributions in binary form must reproduce the above copyright notice,
         this list of conditions and the following disclaimer in the documentation
         and/or other materials provided with the distribution.
      3. Neither the name of STMicroelectronics nor the names of its contributors
         may be used to endorse or promote products derived from this software
         without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
    CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  ******************************************************************************
*/
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f1xx_hal.h"

/* USER CODE BEGIN Includes */

#define  TRAP      __NOP()


//#define	OFF_MIN_DZIEL									// Wylacza najmniejszy zakres przy wlaczonym tlumiku /6
#define	DEF_TIM_SLEEP		(10*60*1000)		// Czas do uspienia

#define VREFCPU       1.2   	// INFO: Vref 1,2V (1,16 do 1,24)
#define VREFLM385     1.2277  // INFO:
#define  VBAT_MIN      2.5


#define U_AUTO_MAX    1.1     // Napiecie max - auto zmiana w gore, overflow
#define U_AUTO_MIN    0.1     // Mapiecie min - auto zmiana dol, z U_AUTO_MAX daje histereze 10%
#define ZAKRESOW      4

#define TLUMIK_1      1
#define TLUMIK_10     10
#define TLUMIK_100    101
#define TLUMIK_1000   1001

#define TIM_KEY_SHORT_MIN   20      // Minimalny czas uznawany za krotkie nacisniescie
#define TIM_KEY_SHORT_MAX   500     // Max czas uznawany za krotkie nacisniecie
#define TIM_KEY_LONG        1000    // Min czas uznawany za dlugie nacisniecie


#define	TIM_WWDG_MIN		30					// Mniej niz 65ms				1/8e6*4096*2^3*(63+1-60) = 250ms
#define	TIM_WWDG_MAX		60					// Wieciej niz 130ms		1/8e6*4096*2^3*(63+1+30) = 500ms
#define	PRE_WWDG				3
#define	TIM_WWDG			300						// co ile ms odswierzac WWDG


#include <stdio.h>
#include <stdlib.h>
#include <cstdlib>

#include <string.h>
#include <ctype.h>
#include "def.h"
#include "ansi.h"

#include "eeprom.h"
#include "crc32.h"

#include "graph.h"
#include "ssd1306_i2c_spi.h"
//#include "SSD1331_Fonts.h"

#include "math.h"

//-----------------------------------------------------------//
//#define  CR    '\r'
//#define LF    '\n'
//#define CR_c  '\r'
//#define LF_c  '\n'
//#define CR_s  "\r"
//#define LF_s  "\n"
#define CRLF  "\r\n"
#define LFCR  "\n\r"
#define TAB   "\t"

#define SOH   '\001'    // 01H      Start of Heading
#define EOT   '\004'    // 04H      End of Transmission
#define FFs   "\014"    // 12 ASCII   Form Feed
#define ESC   '\033'    // 1BH      Escape
#define ESC_s "\033"    // 1BH      Escape
#define XON   '\021'    // 17 ASCII
#define XOFF  '\023'    // 19 ASCII
#define ACK   '\006'    // 06H      Acknowledgement
#define NAK   '\025'    // 15H      Negative Acknowledgement
#define CAN   '\030'    // 18H      Cancel

#define ANSI        "\x1B["     // ESC + "["
#define SGR         ANSI_
#define CSI         ANSI_
#define SGR_        ANSI_
#define CSI_        ANSI_
#define ANSI_RES      "\x1Bc"     // Reset terminala
#define ANSI_CHAR_setukg0   "\x1B(A"  // Set United Kingdom G0 character set
#define ANSI_CHAR_setukg1   "\x1B)A"  // Set United Kingdom G1 character set
#define ANSI_CHAR_setusg0   "\x1B(B"  // Set United States G0 character set
#define ANSI_CHAR_setusg1   "\x1B)B"  // Set United States G1 character set
#define ANSI_CHAR_setspecg0   "\x1B(0"  // Set G0 special chars. & line set
#define ANSI_CHAR_setspecg1   "\x1B)0"  // Set G1 special chars. & line set
#define ANSI_CHAR_setaltg0    "\x1B(1"  // Set G0 alternate character ROM
#define ANSI_CHAR_setaltg1    "\x1B)1"  // Set G1 alternate character ROM
#define ANSI_CHAR_setaltspecg0  "\x1B(2"  // Set G0 alt char ROM and spec. graphics
#define ANSI_CHAR_setaltspecg1  "\x1B)2"  // Set G1 alt char ROM and spec. graphics

#define ANSI_F1   ANSI"11~"
#define ANSI_F2   ANSI"12~"
#define ANSI_F3   ANSI"13~"
#define ANSI_F4   ANSI"14~"
#define ANSI_F5   ANSI"15~"
#define ANSI_F6   ANSI"17~"
#define ANSI_F7   ANSI"18~"
#define ANSI_F8   ANSI"19~"
#define ANSI_F9   ANSI"20~"
#define ANSI_F10    ANSI"21~"
#define ANSI_F11    ANSI"23~"
#define ANSI_F12    ANSI"24~"

// Kody CSI
#define ANSI_CUU      ANSI"A"   // Kursor gra
#define ANSI_CUD      ANSI"B"   // dl
#define ANSI_CUF      ANSI"C"   // prawo
#define ANSI_CUB      ANSI"D"   // lewo
#define ANSI_HOME     ANSI"H"
#define ANSI_CLS      ANSI_HOME""ANSI"2J"
#define ANSI_CURS_OFF   ANSI"?25l"
#define ANSI_CURS_ON    ANSI"?25h"
#define ANSI_CURS_SAVE    ANSI"s"   // Zapamietaj pozycje kursora
#define ANSI_CURS_RESTORE ANSI"u"   // Odtwrz pozycje kursora

// Kody SGR
#define ANSI_OFF      ANSI"0m"
#define ANSI_BOLD     ANSI"1m"
#define ANSI_UNDERSCORE   ANSI"4m"  // Underscore
#define ANSI_BLINK      ANSI"5m"  // Blink
#define ANSI_NEG      ANSI"7m"  // Negative (reverse) image
#define  ANSI_INVERSE    ANSI_NEG
#define ANSI_NEG_OFF  ANSI"27m"
#define ANSI_INVERSE_OFF    ANSI_NEG_OFF
/*
  256-color mode  foreground: ESC[38;5;#m   background: ESC[48;5;#m

  Reserved for extended set foreground color  typical supported next arguments are 5;n where n {\displaystyle n} n is color index (0..255) or 2;r;g;b where r , g , b {\displaystyle r,g,b} r,g,b are red, green and blue color channels (out of 255)
  48  Reserved for extended set background color  typical supported next arguments are 5;n where n {\displaystyle n} n is color index (0..255) or 2;r;g;b where r , g , b {\displaystyle r,g,b} r,g,b are red, green and blue color channels (out of 255)
*/
enum {COL_BLACK, COL_WHITE, COL_INVERSE };
#define ANSI_PEN_BLACK    ANSI"30m"
#define ANSI_PEN_RED    ANSI"31m"
#define ANSI_PEN_GREEN    ANSI"32m"
#define ANSI_PEN_YELLOW   ANSI"33m"
#define ANSI_PEN_BLUE   ANSI"34m"
#define ANSI_PEN_MAGNETA  ANSI"35m"
#define ANSI_PEN_CYAN   ANSI"36m"
#define ANSI_PEN_WHITE    ANSI"37m"

#define ANSI_PEN_SZARY244    ANSI"38;5;244m"
#define ANSI_PEN_SZARY238   ANSI"38;5;238m"
char* AnsiPenRGB( uint8_t rr, uint8_t gg, uint8_t bb )
{
  char static txt[21];
  sprintf( txt, ANSI"38;2;%d;%d;%dm", rr, gg, bb );
  return txt;
}


char* AnsiBackRGB( uint8_t rr, uint8_t gg, uint8_t bb )
{
  char static txt[21];
  sprintf( txt, ANSI"48;2;%d;%d;%dm", rr, gg, bb );
  return txt;
}


#define ANSI_BACK_BLACK   ANSI"40m"
#define ANSI_BACK_RED   ANSI"41m"
#define ANSI_BACK_GREEN   ANSI"42m"
#define ANSI_BACK_YELLOW  ANSI"43m"
#define ANSI_BACK_BLUE    ANSI"44m"
#define ANSI_BACK_MAGNETA ANSI"45m"
#define ANSI_BACK_CYAN    ANSI"46m"
#define ANSI_BACK_WHITE   ANSI"47m"
//-----------------------------------------------------------//

#define	COL_TERM			ANSI_PEN_WHITE


/* USER CODE END Includes */

/* Private variables ---------------------------------------------------------*/
ADC_HandleTypeDef hadc1;
DMA_HandleTypeDef hdma_adc1;

I2C_HandleTypeDef hi2c1;
DMA_HandleTypeDef hdma_i2c1_tx;

//IWDG_HandleTypeDef hiwdg;

UART_HandleTypeDef huart2;

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/

char txt[1000];

char zakres = ZAKRESOW - 1;
uint16_t static tlumik = TLUMIK_1000;
char Rel, Hold, AcDc, dzielnikWE, AutoZ = true;
float napiecieU, napiecieS, ofsetU, wartoscRel, wartoscHOLD, Vrms, offsetV;
int16_t VmaxP, VmaxN;

#define BkpCrc              BKP->DR1
#define BkpUstawienia		    BKP->DR2


#define KEY_HOLD        1
#define KEY_REL         2
#define KEY_ACDC        4
#define KEY_HOLD_LONG   8
#define KEY_HOLD_SHORT  16
#define KEY_REL_LONG   	32
#define KEY_REL_SHORT  	64
uint8_t volatile Keys;
uint16_t volatile TimUartTx, TimZmianaZakresu, TimRefresLcd, TimWwdg=TIM_WWDG, TimDemoLcd = 3000;
uint32_t volatile TimSys, TimSleep = DEF_TIM_SLEEP;

uint8_t AdresI2cLCD = 0x78 >> 1; // 0x7A
//------------------------------------------------------------
//#warning "problem z I2c"
//W:
//HAL_I2C_Init(I2C_HandleTypeDef *hi2c)
//za:
//  __HAL_I2C_DISABLE(hi2c);
//w linii ok 402 dodac:
//    // soft rset I2C
//  I2C1->CR1 |= I2C_CR1_SWRST;
//  HAL_Delay(2);
//  I2C1->CR1 &= ~ I2C_CR1_SWRST;
//------------------------------------------------------------

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_DMA_Init(void);
static void MX_USART2_UART_Init(void);
//static void MX_IWDG_Init(void);
static void MX_I2C1_Init(void);
static void MX_ADC1_Init(void);

/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/

void irq1ms(void);
void GuruMeditation( char *txt1, char *txt2 );

//-------------------------------------------------------------
#define IN_ADC        4
#define PROBEK_ADC    2000
#define PROBEK_REF    50
int16_t volatile probkaAdc, InputAdc, ExtRefAdc, IntRefAdc, TempAdc, InputOfs;
float volatile SumaRms, SumaSrednia;
u8 volatile fl_PomiarZakonczony;

u8 loBat, autozerowanie = true;
float VccCpuE, VccCpu, VccCpuI, Temperature;

//-------------------- IrqAdc ---------------------------------
// trzeba wystartowac:   HAL_ADC_Start_IT(&hadc1);
void HAL_ADC_ConvCpltCallback(ADC_HandleTypeDef* hadc)    // Ponowna deklaracja: __weak void HAL_ADC_ConvCpltCallback(ADC_HandleTypeDef* hadc)
{
  u8 static we = 0;
  uint32_t static input, ExtRef, IntRef, Temp, sumS;
  float static sumV;
  int16_t static maxP, maxN;

  int16_t filteredV;
  float sqV;
  u16 adc = HAL_ADC_GetValue(&hadc1);
  switch ( we ) {
    case 0:
      input += adc;
		
      //-----------------------------------------------------------------------------
      // B) Zastosuj cyfrowe filtry dolnoprzepustowe, aby wyodrebnic offset ,
      // odejmij to - sygnal jest teraz wysrodkowany na 0 zliczeniach.
      //-----------------------------------------------------------------------------
      offsetV = offsetV + ((adc - offsetV) / 4096 );
      filteredV = adc - offsetV;

      //----- Wartosci szczytowe
      if ( filteredV > maxP ) maxP = filteredV;
      if ( filteredV < maxN ) maxN = filteredV;

			//----- Srednia
			sumS += abs( filteredV );
		
      //-----------------------------------------------------------------------------
      // C) Napiecie metody sredniej kwadratowej
      //-----------------------------------------------------------------------------
      //filteredV = adc - offsetV;
      sqV = filteredV * filteredV;                //1) square voltage values
      sumV += sqV;                                //2) sum

      HAL_GPIO_TogglePin( TIME_STAMP_GPIO_Port, TIME_STAMP_Pin ); //todo: test
      break;
    case 1: ExtRef += adc; break;
    case 2: IntRef += adc; break;
    case 3: Temp += adc; break;
  }


  //HAL_GPIO_TogglePin( TIME_STAMP_GPIO_Port, TIME_STAMP_Pin ); //todo: test


  ++probkaAdc;
  if ( (probkaAdc >= PROBEK_ADC && we == 0) ||
       (probkaAdc >= PROBEK_REF && we == 1) ||
       (probkaAdc >= PROBEK_REF && we == 2) ||
       (probkaAdc >= PROBEK_REF && we == 3)  ) {
    probkaAdc = 0;
    if ( ++we >= IN_ADC ) {
      we = 0;
      InputAdc = input / PROBEK_ADC;
      SumaRms = sumV / PROBEK_ADC;
			SumaSrednia = sumS / PROBEK_ADC;
      VmaxP = maxP;
      VmaxN = maxN;

      ExtRefAdc = ExtRef / PROBEK_REF;
      IntRefAdc = IntRef / PROBEK_REF;
      TempAdc = Temp / PROBEK_REF;
      input = ExtRef = IntRef = Temp = sumV = sumS = maxP = maxN = 0;

      fl_PomiarZakonczony = true;
      TRAP;

    }
  }


  ADC_ChannelConfTypeDef sConfig;
  switch ( we )
  {
    case 0: sConfig.Channel = ADC_CHANNEL_4; break;   // Wejscie miernika
    case 1: sConfig.Channel = ADC_CHANNEL_1; break;   // Zewnetrzne napiecie odniesienia 1.2V
    case 2: sConfig.Channel = ADC_CHANNEL_VREFINT; break;   // Wewnetrzne napiecie odniesienia  Vref 1,2V (1,16 do 1,24)
    case 3: sConfig.Channel = ADC_CHANNEL_TEMPSENSOR; break;    // Termometr
  }
  sConfig.Rank = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_239CYCLES_5;
  HAL_ADC_ConfigChannel(&hadc1, &sConfig);
}


/* USER CODE END PFP */

/* USER CODE BEGIN 0 */

//-------------------------------------------------------------
void irq1ms() {
  TimSys++;

  if ( TimUartTx ) TimUartTx--;
  if ( TimRefresLcd ) TimRefresLcd--;
	if ( TimDemoLcd ) {
		if ( TimDemoLcd==1 ) Keys = 0;
			TimDemoLcd--; 
		}
  if ( TimZmianaZakresu ) TimZmianaZakresu--;
	if ( TimSleep ) TimSleep--;
	if ( TimWwdg ) TimWwdg--;
	

  signed char static k[3];
  u8 const filtr = 30 / 2;
  u16 static TimKeyHold, TimKeyRel;

  if ( HAL_GPIO_ReadPin( KEY_HOLD_GPIO_Port, KEY_HOLD_Pin ) ) {
    if ( k[0] < filtr ) k[0]++; else Keys |= KEY_HOLD;
  }
  else {
    if ( k[0] > -filtr ) k[0]--; else Keys &= ~KEY_HOLD;
    if (  TimKeyHold > TIM_KEY_SHORT_MIN && TimKeyHold < TIM_KEY_SHORT_MAX ) {
      Keys |= KEY_HOLD_SHORT;           // Ustawienie flagi krotkiego wcisniecia przycisku, kasowanie przez USER-a
      TRAP;
    }
    TimKeyHold = 0;
  }
  u8 keyHold = Keys & KEY_HOLD;
  if ( keyHold && TimKeyHold < TIM_KEY_LONG + 1 ) TimKeyHold++; // Liczymy czas wcisniecia klawisza HOLD
  if ( TimKeyHold == TIM_KEY_LONG ) Keys |= KEY_HOLD_LONG;    // Ustawienie flagi dlugiego wcisniecia przycisku, kasowanie przez USER-a


  if ( ! HAL_GPIO_ReadPin( KEY_REL_GPIO_Port, KEY_REL_Pin ) ) {
    if ( k[1] < filtr ) k[1]++; else Keys |= KEY_REL;
  }
  else {
    if ( k[1] > -filtr ) k[1]--; else Keys &= ~KEY_REL;
    if (  TimKeyRel > TIM_KEY_SHORT_MIN && TimKeyRel < TIM_KEY_SHORT_MAX ) {
      Keys |= KEY_REL_SHORT;           // Ustawienie flagi krotkiego wcisniecia przycisku, kasowanie przez USER-a
      TRAP;
    }
    TimKeyRel = 0;
  }
  u8 keyRel = Keys & KEY_REL;
  if ( keyRel && TimKeyRel < TIM_KEY_LONG + 1 ) TimKeyRel++; 	// Liczymy czas wcisniecia klawisza REL
  if ( TimKeyRel == TIM_KEY_LONG ) Keys |= KEY_REL_LONG;    // Ustawienie flagi dlugiego wcisniecia przycisku, kasowanie przez USER-a


  if ( ! HAL_GPIO_ReadPin( KEY_ACDC_GPIO_Port, KEY_ACDC_Pin ) ) {
    if ( k[2] < filtr ) k[2]++; else Keys |= KEY_ACDC;
  }
  else {
    if ( k[2] > -filtr ) k[2]--; else Keys &= ~KEY_ACDC;
  }

	
	u8 static prevKeys;
		if( prevKeys != Keys ){
			prevKeys = Keys;
		TimSleep = DEF_TIM_SLEEP;
	}
}


//-------------------------------------------------------------
void GuruMeditation( char *txt1, char *txt2 ) {

  ssd1306_rotation( 2 );
  ssd1306_init( 1 );

  for (u8 x = 0; x < 10; x++) {
    strcpy( txt, CRLF""ANSI_PEN_RED );
    HAL_UART_Transmit(&huart2, (uint8_t*)txt, sizeof(txt), 100 );
    HAL_UART_Transmit(&huart2, (uint8_t*)txt1, sizeof(txt1), 100 );
    strcpy( txt, "" );
    HAL_UART_Transmit(&huart2, (uint8_t*)txt, sizeof(txt), 100 );
    HAL_UART_Transmit(&huart2, (uint8_t*)txt2, sizeof(txt2), 100 );

    ssd1306_clearDisplay();
    ssd1306_SetFont( 0x1616 );
    ssd1306_PrintString( 0, 0, txt1, COL_WHITE);
    ssd1306_PrintString( 0, 16, txt2, COL_WHITE);
    ssd1306_display( 0 );
    for (u32 l = 0; l < 4e5; l++) __NOP();

    ssd1306_clearDisplay();
    ssd1306_PrintString( 0, 0, "Guru", COL_WHITE);
    ssd1306_PrintString( 0, 16, "meditation", COL_WHITE);
    ssd1306_display( 0 );
    for (u32 l = 0; l < 2e5; l++) __NOP();
  }
  NVIC_SystemReset();
}



//-------------------------------------------------------------
u16 zakMax;
//-------------------------------------------------------------
u8 PrintDC( char * txt ) {
  u8 jednostki = 1;		// 0-mVdc, 1-Vdc
	float napiecieW = napiecieS;

	

  if ( Hold ) napiecieW = wartoscHOLD;
  if ( napiecieS > U_AUTO_MAX ){
		strcpy( txt, " Overflow" );
	}
  else if ( napiecieS < -U_AUTO_MAX ){
		strcpy( txt, "-Overflow" );
	}
  else {
    if ( ! dzielnikWE ) {
      switch ( tlumik ) {
        case TLUMIK_1:
          if ( napiecieW * tlumik < 1.0 ){
						sprintf( txt, "%03.0f", napiecieW * tlumik * 1000 );  // do 1 V
						jednostki = 0;
					}
          else sprintf( txt, "%0.3f", napiecieW * tlumik );   // 1 - 1,1 V
					zakMax = 1; 
          break;
        case TLUMIK_10:
          sprintf( txt, "%0.2f", napiecieW * tlumik );    // 1.10 - 11 V
					zakMax = 11; 
          break;
        case TLUMIK_100:
          sprintf( txt, "%0.1f", napiecieW * tlumik );    // 11.0 - 110 V
					zakMax = 110; 				
          break;
        case TLUMIK_1000:
          sprintf( txt, "%0.0f", napiecieW * tlumik );    // 110 - 1100 V
					zakMax = 1100; 				
          break;
        default: strcpy( txt, "Err DIV");// GuruMeditation( char *txt1, char *txt2 );
      }
    }
    else {
      TRAP;
      switch ( tlumik ) {
				#ifndef OFF_MIN_DZIEL
        case TLUMIK_1:
          sprintf( txt, "%0.2f", napiecieW * tlumik );     // 1 - 1,1 V
					zakMax = 1; 
          break;
				#endif
        case TLUMIK_10:
          sprintf( txt, "%0.1f", napiecieW * tlumik * 6  );    // 6.6 - 66 V
					zakMax = 11 * 6; 
          break;
        case TLUMIK_100:
          sprintf( txt, "%0.0f", napiecieW * tlumik * 6.5005500550055  );    // 66 - 660 V
					// dla float i tak znaczenie ma 7 cyfr, mozna zmienic na double (15 cyfr) na ARM zadziala, na AVR juz nie
					zakMax = 110 * 6; 
          break;
        case TLUMIK_1000:
          sprintf( txt, "%04.0f", napiecieW * tlumik * 6.55000555000555   );  // 660 - 6600 V
					// float i tak znaczenie ma 7 cyfr, mozna zmienic na double (15 cyfr) na ARM zadziala, na AVR juz nie
					zakMax = 1100 * 6; 
				break;
        default: strcpy( txt, "Err DIV");// GuruMeditation( char *txt1, char *txt2 );
      }
    }
  }
	
	
	return jednostki;
}


//-------------------------------------------------------------
u8 PrintAC( char * txt ) {
	u8 jednostki = 1;		// 0-mVdc, 1-Vdc
	
	//todo:
  sprintf( txt, "%03.0f", Vrms ); jednostki = 0;
	
	
	return jednostki;
}


//-------------------------------------------------------------
void AutoDC() {
  float n = napiecieS;
	
		
  if ( n < 0 ) n = -n;
  if ( n > U_AUTO_MAX ) {
    TRAP;
    if ( zakres < ZAKRESOW - 1 ) {
      zakres++;
      TimZmianaZakresu = 500;    // po zmianie zakresu timeout
    }
  }
  else if ( n < U_AUTO_MIN ) {
		#ifndef OFF_MIN_DZIEL
		 if ( zakres ) {
      TRAP;
      zakres--;
      TimZmianaZakresu = 500;
		 }
   #else
    if ( zakres && !dzielnikWE ) {
      TRAP;
      zakres--;
      TimZmianaZakresu = 500;
    }
    else if ( (zakres > 1) && dzielnikWE ) {    // dla dzielnika(tlumika) przez 10 najnizszy zakres nieosiagalny
      TRAP;
      zakres--;
      TimZmianaZakresu = 500;
		}
		#endif
	}
}


//-------------------------------------------------------------
void AutoAC() {
	//todo:
}


//-------------------------------------------------------------
u8 FL_Iwdg, FL_Bod, FL_WakeUp;

//-------------------------------------------------------------


/* USER CODE END 0 */

/**
    @brief  The application entry point.

    @retval None
*/
int main(void)
{
  /* USER CODE BEGIN 1 */

  //----- Zatrzymuj IWDG i WWDG podczas debugowania -----//
  __HAL_DBGMCU_FREEZE_IWDG(); // DBGMCU -> APB1FZ |= DBGMCU_APB1_FZ_DBG_IWDG_STOP;
	__HAL_DBGMCU_FREEZE_WWDG();
	
  //----- Nie rozlaczaj z debugerem po usypieniu, stop, itp
  DBGMCU->CR |= DBGMCU_CR_DBG_SLEEP | DBGMCU_CR_DBG_STOP | DBGMCU_CR_DBG_STANDBY;   //


  __HAL_DBGMCU_FREEZE_TIM1();
  __HAL_DBGMCU_FREEZE_TIM2();
  __HAL_DBGMCU_FREEZE_TIM3();
  __HAL_DBGMCU_FREEZE_TIM4();

	
	  //----- Flaga wybudzenia -----//
  if ( __HAL_PWR_GET_FLAG(PWR_FLAG_WU) ) FL_WakeUp = 1;
  __HAL_PWR_CLEAR_FLAG(PWR_FLAG_WU);    // INFO: bez tego nie da sie wypudzic CPU
	
	
  //----- Flagi resetu -----//
  if ( RCC->CSR & (1 << 29) ) FL_Iwdg = 1; // RCC->CSR & RCC_FLAG_IWDGRST ???
  if ( RCC->CSR & (1 << 27) ) FL_Bod = 1;
  __HAL_RCC_CLEAR_RESET_FLAGS();  // RCC->CSR |= RCC_CSR_RMVF;    // Kasuje flagi
	

  //----- Wygenerowanie unikalnego ID -----//
  uint32_t id_cpu[3];
  HAL_GetUID(id_cpu);
  //uint32_t crc32cpu = 0xFFFFFFFF;
  //crc32cpu = xcrc32( crc32cpu, id_cpu[0] );
  //crc32cpu = xcrc32( crc32cpu, id_cpu[1] );
  //crc32cpu = xcrc32( crc32cpu, id_cpu[2] );


  //----- Wlaczenie backup Domain -----//
  RCC->APB1ENR |= RCC_APB1ENR_PWREN | RCC_APB1ENR_BKPEN;
  PWR->CR = PWR_CR_DBP;
  BKP->CR = BKP_CR_TPAL;// | BKP_CR_TPE;
  BKP->CR &= ~BKP_CR_TPE;   // Tamper (PC13) wylaczony


	//----- Ustawienie zmiennych BackupDomain -----//
  //u8 flFirstPowerOn = false;
  if ( BkpCrc != 0x12cb ) {
    BkpCrc = 0x12cb;
    BkpUstawienia = 0;		//todo: obsluzyc AD/DC, REL wymagaloby zapamietania wartosci, HOLD troche bez sensu
    //flFirstPowerOn = true;
  }
	
	
  /* USER CODE END 1 */

  /* MCU Configuration----------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_USART2_UART_Init();
  //  MX_IWDG_Init();
  MX_I2C1_Init();
  MX_ADC1_Init();
  /* USER CODE BEGIN 2 */

  HAL_ADC_Start_IT(&hadc1);

  ssd1306_rotation( 2 );
  ssd1306_init( 1 );


	//----- WWDG init -----//
	RCC->APB1ENR |= RCC_APB1ENR_WWDGEN;		// Wlaczenie taktowania WWDG
	__DSB();
	WWDG->CR = WWDG_CR_WDGA | WWDG_CR_T6 | TIM_WWDG_MAX;
	WWDG->CFR = WWDG_CFR_EWI | PRE_WWDG<<7 | WWDG_CFR_W6 | TIM_WWDG_MIN;			// 1<<7 - preskaler na 1
  WWDG->SR &= ~WWDG_SR_EWIF;	// Kasuj flage przerwania od WWDG
		
		
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  // LOOP:
  while (1)
  {
    __WFI();
    //HAL_IWDG_Refresh(&hiwdg);

		if( !TimWwdg ){
			TimWwdg = TIM_WWDG;
			WWDG->CR = WWDG_CR_WDGA | WWDG_CR_T6 | TIM_WWDG_MAX;
		}
		

		// SLEEP:
		if( !TimSleep || (Keys & KEY_REL_LONG) ){	
			sprintf( txt, ANSI_PEN_YELLOW"Sleep..."CRLF ); HAL_UART_Transmit(&huart2, (uint8_t*)txt, sizeof(txt), 100 );

			HAL_Delay( 30 );				// Moze trwa transmisja do LCD przez DMA? Max czas ponizej 20ms
			ssd1306_command(SSD1306_DISPLAYOFF);      // uspienie wyswietlacza
				
			
			__HAL_PWR_CLEAR_FLAG(PWR_FLAG_WU);
      PWR->CSR |= PWR_CSR_EWUP;
      PWR->CR |= PWR_CR_CWUF; // clear the WUF flag after 2 clock cycles
      //    PWR->CR |= PWR_CR_ULP;  // V_{REFINT} is off in low-power mode
      PWR->CR |= PWR_CR_PDDS; // Enter Standby mode when the CPU enters deepsleep

      SCB->SCR |= SCB_SCR_SLEEPDEEP_Msk; // low-power mode = stop mode
      SCB->SCR |= SCB_SCR_SLEEPONEXIT_Msk; // reenter low-power mode after ISR


      __WFI(); // enter low-power mode

      //      HAL_PWR_EnterSTANDBYMode();
      //      HAL_PWR_EnterSTOPMode(PWR_LOWPOWERREGULATOR_ON, PWR_STOPENTRY_WFI)
		}
		
		
    uint16_t static TimPomiar;
    uint32_t static prevTimPomiar;
    if ( fl_PomiarZakonczony ) {
      fl_PomiarZakonczony = false;
      TimPomiar = TimSys - prevTimPomiar; prevTimPomiar = TimSys;

      VccCpuI = VREFCPU * 4096 / IntRefAdc;
      VccCpuE = VREFLM385 * 4096 / ExtRefAdc;

      VccCpu = VccCpuE;// VccCpuI;
      if ( VccCpu < VBAT_MIN ) loBat = true; else loBat = false;

      /*
              const float V25 = 0.76; // [Volts]
              const float Avg_slope = 0.025; //[Volts/degree]
              float Vsense = (VccCpu * TempAdc) / (4096 - 1); // Przeliczenie wartosci zmierzonej na napiecie
              Temperature = ((Vsense - V25) / Avg_slope) + 25; // Obliczenie temperatury
      */

      //----- Autozerowanie ------//
      if ( autozerowanie  ) {

        //----- Multiplekser na GND (we 3)
        HAL_GPIO_WritePin( T_OFF_GPIO_Port, T_OFF_Pin, GPIO_PIN_RESET );
        HAL_GPIO_WritePin( T10_GPIO_Port, T10_Pin, GPIO_PIN_SET );
        HAL_GPIO_WritePin( T100_GPIO_Port, T100_Pin, GPIO_PIN_SET );

        InputOfs = InputAdc;    // todo: liczyc srednia
        ofsetU = InputAdc  * VccCpu / 4096;
        ofsetU = 0.59;  // todo: cos nie tak, gdy muz zwiera z masa to jakies napiecie pojawia sie
				//todo: na razie ofset ustawiony w programie 
			}
		}


    if ( !TimUartTx ) {
      TimUartTx = 2000;

			extern u8 ssd1306_stI2c;
      u16 static line = 1;
      sprintf( txt, COL_TERM"%3d VccCpu=%0.3f InputAdc=%d InputOfs=%d ofsetU=%0.3f tlumik=%d dzielnik=%d zakMax=%d TimSleep=%d ssd1306_stI2c=%d"CRLF \
						"    SumaRms=%0.1f napiecieS=%0.4f SumaSrednia=%0.3f Vrms=%0.3f offsetV=%0.3f VmaxP=%0.3f, VmaxN=%0.3f"CRLF \
						"    TimPomiar=%dms"CRLF,
            line++, VccCpu, InputAdc, InputOfs, ofsetU, tlumik, dzielnikWE, zakMax, TimSleep/1000, ssd1306_stI2c,
						SumaRms, napiecieS, (SumaSrednia * VccCpu / 4096),
            Vrms, offsetV, (VmaxP * VccCpu / 4096), (VmaxN * VccCpu / 4096), TimPomiar  );
      HAL_UART_Transmit_IT(&huart2, (uint8_t*)txt, sizeof(txt) );
    }


    if ( !TimRefresLcd & !TimDemoLcd ) {
      TimRefresLcd = 200;		// przy 100 wyswietlacz kaszni sie
      autozerowanie = false;

      dzielnikWE = HAL_GPIO_ReadPin( DZIEL_GPIO_Port, DZIEL_Pin );


      uint8_t pozX = 0, pozY = 0;


      napiecieU = InputAdc * VccCpu / 4096;
      napiecieS = ( napiecieU - ofsetU ) * 2;         
      Vrms = sqrt(SumaRms);


			// Zmiana o +/- 20% zeruje czas usypiania
			float static prevNapiecie;
			if( napiecieS > (prevNapiecie + 0.2) || napiecieS < (prevNapiecie - 0.2) ){					
					prevNapiecie = napiecieS;
					TimSleep = DEF_TIM_SLEEP;
      }
			
			
      u8 static prevKeyRel, prevAuto;
      u8 k = Keys & KEY_REL_SHORT;
			Keys &= ~KEY_REL_SHORT;
      if ( prevKeyRel != k ) {    // Jesli zmiana stanu przycisku
        prevKeyRel = k;

        if ( k ) {                // Gdy nacisniety
          Rel ^= 1;               // Wlacz/wylacz REL
          if ( Rel ) {
            prevAuto = AutoZ; AutoZ = 0;   // Jesli zmiana na wlaczony wylacz tryb auto zapamietuja poprzedni stan
            wartoscRel = napiecieS;
          }
          else { 							// Jesli REL wylaczony 
						wartoscRel = 0;  	// kasuj wartosc REL
						AutoZ = prevAuto;	// Przywroc stan AUTO
					}
        }
      }
      napiecieS -= wartoscRel;


      if ( Keys & KEY_HOLD_LONG ) {
        Keys &= ~KEY_HOLD_LONG;     // kasuj flage
        AutoZ ^= 1;
				if( dzielnikWE ) AutoZ = false;	// Je3sli wlaczony dzielnik / 6 to nie ma trybu auto
      }
      if ( Keys & KEY_HOLD_SHORT ) {
        Keys &= ~KEY_HOLD_SHORT;
        Hold ^= 1;
        if ( Hold ) wartoscHOLD = napiecieS;
      }


      ssd1306_clearDisplay();

      //----- Wyswietlenie napiecia
			u8 jednostki =1;
      if ( !AcDc ) jednostki = PrintDC( txt );
      else jednostki = PrintAC( txt );
      ssd1306_SetFont( 0x1616 );
      pozX = ssd1306_PrintString( 0, pozY, txt, COL_WHITE);
			ssd1306_SetFont( 0x507 );
			{
			u8 y = 0;
			if( AcDc ) y = 8;
			if( !jednostki ) pozX = ssd1306_PrintString( pozX, pozY+y, "m", COL_WHITE);
			if( !AcDc ) ssd1306_PrintString( pozX, pozY+y, "Vdc", COL_WHITE);
			else  ssd1306_PrintString( pozX, pozY+y, "Vac", COL_WHITE);
			}
			
      //----- Wyswietlenie dodatkowych informacji
      ssd1306_SetFont( 0x0705 );
      pozY += 16;
      pozX = 0;
			u8 const space = 4;

      if ( Rel )pozX = ssd1306_PrintString( pozX, pozY, "REL", COL_BLACK ) + space;

      if ( Hold ) pozX = ssd1306_PrintString( pozX, pozY, "HOLD" , COL_BLACK );
      else if ( ! AutoZ ) pozX = ssd1306_PrintString( pozX, pozY, "MAN", COL_BLACK ) + space;
      else pozX = ssd1306_PrintString( pozX, pozY, "AUTO", COL_WHITE ) + space;
			//----- LoBat 
      ssd1306_SetFont( 0x0705 );
      if ( loBat & (TimSys % 1000 > 500) ) ssd1306_PrintString( pozX, pozY, "LoBat" , COL_BLACK );

			//----- Bargraf
			pozY += 8;
			for(u8 x=0; x<111; x++){
				if( (x % 10) == 0 ) ssd1306_drawFastVLine( x+6, pozY+3, 5, COL_WHITE );	// pozY+3, 5 daje razem 8
				if( x == 0 || x == 50 || x == 100 ) ssd1306_drawFastVLine( x+6, pozY, 8, COL_WHITE );
				}
			for(u8 x=0; x<111; x++){
				if( x < abs((int)(napiecieS * 100)) ) ssd1306_drawFastVLine( x+6, pozY+6, 3, COL_WHITE ); //  pozY+6, 3 daje razem 8
				}
			sprintf( txt, "%dV", zakMax );	
			pozX = ssd1306_PrintString( SSD1306_LCDWIDTH-30, pozY-8, txt, COL_WHITE);
				
			
      ssd1306_display( 1 );


      //----- Automatyczna zmiana zakresu
      if ( !TimZmianaZakresu && AutoZ) {
        TimZmianaZakresu = 100;

        if ( !AcDc ) AutoDC();
        else AutoAC();
      }
			u8 static prevDzielnik;
			if( prevDzielnik != dzielnikWE ){
				prevDzielnik = dzielnikWE;
				
				if( dzielnikWE ) AutoZ = false; else AutoZ = true;
			}
			

      //----- Manualna zmiana zakresu
      if ( ! AutoZ ) {  // Jesli tryb manualny to KEY_ACDC zmienia zakres
        u8 static prevKey = true;
        u8 Key = Keys & KEY_ACDC;
        if ( prevKey != Key ) {
          prevKey = Key;

          if ( Key ) {
            Rel = false;    // Zmiana zakresu wylacza tryb REL
            zakres++;
            if ( zakres >= ZAKRESOW ) zakres = 0;
						#ifdef OFF_MIN_DZIEL
            if ( dzielnikWE && !zakres ) zakres = 1;  // dla dzielnika(tlumika) przez 10 najnizszy zakres nieosiagalny
						#endif
          }
        }
      }
      else {      // Jesli tryb auto to KEY_ACDC przelacza pomiedzy pmiarem DC a AC
        u8 static prevKey = true;
        u8 Key = Keys & KEY_ACDC;
        if ( prevKey != Key ) {
          prevKey = Key;

					if ( Key ) AcDc ^= 1;
          //todo: na razie nie ma pomiaru AC  
        }
      }


      switch ( zakres ) {
        case 0:
          tlumik = 1;
          HAL_GPIO_WritePin( T_OFF_GPIO_Port, T_OFF_Pin, GPIO_PIN_SET );
          break;
        case 1:
          tlumik = 10;
          HAL_GPIO_WritePin( T_OFF_GPIO_Port, T_OFF_Pin, GPIO_PIN_RESET );
          HAL_GPIO_WritePin( T10_GPIO_Port, T10_Pin, GPIO_PIN_RESET );
          HAL_GPIO_WritePin( T100_GPIO_Port, T100_Pin, GPIO_PIN_RESET );
          break;
        case 2:
          tlumik = 101;
          HAL_GPIO_WritePin( T_OFF_GPIO_Port, T_OFF_Pin, GPIO_PIN_RESET );
          HAL_GPIO_WritePin( T10_GPIO_Port, T10_Pin, GPIO_PIN_SET );
          HAL_GPIO_WritePin( T100_GPIO_Port, T100_Pin, GPIO_PIN_RESET );
          break;
        default:
          tlumik = 1001;
          HAL_GPIO_WritePin( T_OFF_GPIO_Port, T_OFF_Pin, GPIO_PIN_RESET );
          HAL_GPIO_WritePin( T100_GPIO_Port, T100_Pin, GPIO_PIN_SET );
          HAL_GPIO_WritePin( T10_GPIO_Port, T10_Pin, GPIO_PIN_RESET );
      }

    } // END RefresLcd


    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */

  }
  /* USER CODE END 3 */

}

/**
    @brief System Clock Configuration
    @retval None
*/
void SystemClock_Config(void)
{

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;
  RCC_PeriphCLKInitTypeDef PeriphClkInit;

  /**Initializes the CPU, AHB and APB busses clocks
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI | RCC_OSCILLATORTYPE_LSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = 16;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI_DIV2;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  /**Initializes the CPU, AHB and APB busses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK | RCC_CLOCKTYPE_SYSCLK
                                | RCC_CLOCKTYPE_PCLK1 | RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_0) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_ADC;
  PeriphClkInit.AdcClockSelection = RCC_ADCPCLK2_DIV2;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  /**Configure the Systick interrupt time
  */
  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq() / 1000);

  /**Configure the Systick
  */
  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}

/* ADC1 init function */
static void MX_ADC1_Init(void)
{

  ADC_ChannelConfTypeDef sConfig;

  /**Common config
  */
  hadc1.Instance = ADC1;
  hadc1.Init.ScanConvMode = ADC_SCAN_DISABLE;
  hadc1.Init.ContinuousConvMode = ENABLE;
  hadc1.Init.DiscontinuousConvMode = DISABLE;
  hadc1.Init.ExternalTrigConv = ADC_SOFTWARE_START;
  hadc1.Init.DataAlign = ADC_DATAALIGN_RIGHT;
  hadc1.Init.NbrOfConversion = 1;
  if (HAL_ADC_Init(&hadc1) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  /**Configure Regular Channel
  */
  sConfig.Channel = ADC_CHANNEL_1;
  sConfig.Rank = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_239CYCLES_5;
  if (HAL_ADC_ConfigChannel(&hadc1, &sConfig) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

}

/* I2C1 init function */
static void MX_I2C1_Init(void)
{

  hi2c1.Instance = I2C1;
  hi2c1.Init.ClockSpeed = 400000;
  hi2c1.Init.DutyCycle = I2C_DUTYCYCLE_2;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

}

/* IWDG init function */
/*
  static void MX_IWDG_Init(void)
  {

  hiwdg.Instance = IWDG;
  hiwdg.Init.Prescaler = IWDG_PRESCALER_4;
  hiwdg.Init.Reload = 4095;
  if (HAL_IWDG_Init(&hiwdg) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  }
*/


/* USART2 init function */
static void MX_USART2_UART_Init(void)
{

  huart2.Instance = USART2;
  huart2.Init.BaudRate = 115200;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

}

/**
    Enable DMA controller clock
*/
static void MX_DMA_Init(void)
{
  /* DMA controller clock enable */
  __HAL_RCC_DMA1_CLK_ENABLE();

  /* DMA interrupt init */
  /* DMA1_Channel1_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel1_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel1_IRQn);
  /* DMA1_Channel6_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel6_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel6_IRQn);

}

/** Configure pins as
          Analog
          Input
          Output
          EVENT_OUT
          EXTI
*/
static void MX_GPIO_Init(void)
{

  GPIO_InitTypeDef GPIO_InitStruct;

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, POW1_Pin | POW2_Pin | POW3_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, T100_Pin | T10_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, T_OFF_Pin | T2_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pins : POW1_Pin POW2_Pin POW3_Pin */
  GPIO_InitStruct.Pin = POW1_Pin | POW2_Pin | POW3_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pins : T100_Pin T10_Pin */
  GPIO_InitStruct.Pin = T100_Pin | T10_Pin | TIME_STAMP_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : T5_Pin T2_Pin */
  GPIO_InitStruct.Pin = T_OFF_Pin | T2_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pins : DZIEL_Pin KEY_ACDC_Pin KEY_REL_Pin */
  GPIO_InitStruct.Pin = DZIEL_Pin | KEY_ACDC_Pin | KEY_REL_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
    @brief  This function is executed in case of error occurrence.
    @param  file: The file name as string.
    @param  line: The line in file as a number.
    @retval None
*/
void _Error_Handler(char *file, int line)
{
  /* USER CODE BEGIN Error_Handler_Debug */

  char txt2[20];
  sprintf( txt2, "Line: %d", line );
  GuruMeditation( file, txt2 );

  /* User can add his own implementation to report the HAL error return state */
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
    @brief  Reports the name of the source file and the source line number
            where the assert_param error has occurred.
    @param  file: pointer to the source file name
    @param  line: assert_param error line source number
    @retval None
*/
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */

  char txt2[20];
  sprintf( txt2, "Line: %d", line );
  GuruMeditation( (char*)file, txt2 );


  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/**
    @}
*/

/**
    @}
*/

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
